﻿<UserControl x:Class="VECTO3GUI2020.Views.Multistage.CustomControls.MultiStageParameter"
             xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
             xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" 
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008" 
             xmlns:local="clr-namespace:VECTO3GUI2020.Views.Multistage.CustomControls"
             mc:Ignorable="d" 
             d:DesignHeight="450" d:DesignWidth="800" Name="MultistageParameterControl">



    <Grid>

        <!-- _____________________________________________ Text mode ___________________________________________________________________-->
        <Grid Visibility="{Binding ElementName=MultistageParameterControl, 
        Path=Mode, 
        Converter={StaticResource ParameterModeToVisibilityConverter}, ConverterParameter={x:Static local:MultistageParameterViewMode.TEXTBOX}}">
            <Grid.ColumnDefinitions>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="1*" SharedSizeGroup="N"/>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="1*" SharedSizeGroup="N"/>
            </Grid.ColumnDefinitions>

            <Label x:Name="label" >
                <PriorityBinding>
                    <Binding ElementName="MultistageParameterControl" Path="Label"  Converter="{StaticResource NullToUnsetValue}"></Binding>
                    <Binding ElementName="MultistageParameterControl" Path="GeneratedLabelText"></Binding>
                </PriorityBinding>
            </Label>
            <CheckBox Grid.Column="1" HorizontalAlignment="Center" VerticalAlignment="Center" Name="CheckBox"
                  Visibility="{Binding ShowCheckBox, 
                    ElementName=MultistageParameterControl, 
                    Converter={StaticResource BooleanToVisibilityConverter}}"
                  IsChecked="{Binding EditingEnabled, 
            ElementName=MultistageParameterControl, 
            Mode=TwoWay}"/>

            <TextBox x:Name="textBox" Grid.Column="2" VerticalAlignment="Center" Margin="2 0 2 0" IsReadOnly="True" IsTabStop="False"
                 Text="{Binding ElementName=MultistageParameterControl, Path=PreviousContent, Converter={StaticResource SIValueToStringConverter}}" 
                 
                 Style="{DynamicResource TextBoxStyle1}"
                 Visibility="{Binding Optional, 
                    ElementName=MultistageParameterControl, Converter={StaticResource BooleanToVisibilityConverter}, UpdateSourceTrigger=PropertyChanged}"/>

            <TextBox Grid.Column="3" Name ="TextBoxContent" VerticalAlignment="Center" Margin="2 0 2 0" 
                 Text="{Binding Content,
                    ElementName=MultistageParameterControl, 
                    Converter={StaticResource SIValueToStringConverter}, 
                    UpdateSourceTrigger=PropertyChanged}"
                 Style="{DynamicResource TextBoxStyle1}"
                 IsReadOnly="{Binding ElementName=MultistageParameterControl,
            Path=EditingEnabled, Converter={StaticResource InvertBoolConverter}}" MouseDoubleClick="Control_OnMouseDoubleClick"/>

            <Label Grid.Column="4" x:Name="AutoUnitLabel"
               Content="{Binding DummyContent, ElementName=MultistageParameterControl, Converter={StaticResource SIToUnitStringConverter}}">
            </Label>
        </Grid>


        <!--_________________________________________________ComboBoxMode____________________________________________________________________-->
        <Grid Visibility="{Binding ElementName=MultistageParameterControl, 
        Path=Mode, 
        Converter={StaticResource ParameterModeToVisibilityConverter}, ConverterParameter={x:Static local:MultistageParameterViewMode.COMBOBOX}}">
            <Grid.ColumnDefinitions>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="1*" SharedSizeGroup="N"/>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="1*" SharedSizeGroup="N"/>
            </Grid.ColumnDefinitions>

            <Label x:Name="label1">
                <PriorityBinding>
                    <Binding ElementName="MultistageParameterControl" Path="Label" Converter="{StaticResource NullToUnsetValue}"></Binding>
                    <Binding ElementName="MultistageParameterControl" Path="GeneratedLabelText"></Binding>
                </PriorityBinding>
            </Label>
            <CheckBox Grid.Column="1" HorizontalAlignment="Center" VerticalAlignment="Center" Name="CheckBoxCombo"
                  Visibility="{Binding ShowCheckBox, 
                    ElementName=MultistageParameterControl, 
                    Converter={StaticResource BooleanToVisibilityConverter}}"
                  IsChecked="{Binding EditingEnabled, 
            ElementName=MultistageParameterControl, 
            Mode=TwoWay}"/>

            <ComboBox x:Name="comboBox" Grid.Column="2" HorizontalAlignment="Stretch" VerticalAlignment="Center" Margin="2 0 2 0" IsTabStop="False" Visibility="{Binding Optional, 
                    ElementName=MultistageParameterControl, 
                    Converter={StaticResource BooleanToVisibilityConverter}}" IsHitTestVisible="False" Focusable="False" IsEditable="False"
                      SelectedValue="{Binding PreviousContent, Mode=TwoWay, ElementName=MultistageParameterControl}"
                      ItemsSource="{Binding GeneratedListItems, ElementName=MultistageParameterControl}">
                <ComboBox.ItemTemplate>
                    <DataTemplate>
                        <TextBlock x:Name="textBlock" Text="{Binding Converter={StaticResource EnumConverter}}" />
                    </DataTemplate>
                </ComboBox.ItemTemplate>
            </ComboBox>

            <!--SelectedIndex="{Binding EditingEnabled, ElementName=MultistageParameterControl, Converter={StaticResource BoolToIntConverter}}"-->
            <!--ItemsSource="{Binding ListItems, ElementName=MultistageParameterControl}"-->
            <ComboBox x:Name="comboBoxCurrent" Grid.Column="3" HorizontalAlignment="Stretch" VerticalAlignment="Center" Margin="2 0 2 0" 
                      SelectedItem="{Binding Content, Mode=TwoWay, ElementName=MultistageParameterControl, ValidatesOnExceptions=True, UpdateSourceTrigger=PropertyChanged}"
                      IsEnabled="{Binding EditingEnabled, ElementName=MultistageParameterControl}"
                      IsEditable="False" MouseDoubleClick="Control_OnMouseDoubleClick">
                <ComboBox.ItemsSource>
                    <PriorityBinding>
                        <Binding Path="ListItems" ElementName="MultistageParameterControl" Converter="{StaticResource NullToUnsetValue}" UpdateSourceTrigger="PropertyChanged"/>
                        <Binding Path="GeneratedListItems" ElementName="MultistageParameterControl" UpdateSourceTrigger="PropertyChanged"/>
                    </PriorityBinding>
                </ComboBox.ItemsSource>
                <ComboBox.ItemTemplate>
                    <DataTemplate>
                        <TextBlock x:Name="textBlock" Text="{Binding Converter={StaticResource EnumConverter}}" />
                    </DataTemplate>
                </ComboBox.ItemTemplate>
            </ComboBox>


            <Label x:Name="label2" Grid.Column="4"
               Content="{Binding DummyContent, ElementName=MultistageParameterControl, Converter={StaticResource SIToUnitStringConverter}}">
            </Label>
        </Grid>

        <!--_________________________________________________CheckBoxMode____________________________________________________________________-->
        <Grid Visibility="{Binding ElementName=MultistageParameterControl, 
        Path=Mode, 
        Converter={StaticResource ParameterModeToVisibilityConverter}, ConverterParameter={x:Static local:MultistageParameterViewMode.CHECKBOX}}">
            <Grid.ColumnDefinitions>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="1*" SharedSizeGroup="N"/>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="4*" SharedSizeGroup="W"/>
                <ColumnDefinition Width="1*" SharedSizeGroup="N"/>
            </Grid.ColumnDefinitions>

            <Label x:Name="label3">
                <PriorityBinding>
                    <Binding ElementName="MultistageParameterControl" Path="Label"  Converter="{StaticResource NullToUnsetValue}"></Binding>
                    <Binding ElementName="MultistageParameterControl" Path="GeneratedLabelText"></Binding>
                </PriorityBinding>
            </Label>
            <CheckBox Grid.Column="1" HorizontalAlignment="Center" VerticalAlignment="Center" Name="CheckBoxCheckBox" 
                  Visibility="{Binding ShowCheckBox, 
                    ElementName=MultistageParameterControl, 
                    Converter={StaticResource BooleanToVisibilityConverter}}"
                  IsChecked="{Binding EditingEnabled, 
            ElementName=MultistageParameterControl, 
            Mode=TwoWay}"
                 />

            <CheckBox x:Name="checkBox" Grid.Column="2" VerticalAlignment="Center" HorizontalAlignment="Center" IsTabStop="False" IsChecked="{Binding ElementName=MultistageParameterControl, 
                Path=PreviousContent, 
                Converter={StaticResource XToBoolConverter}}" IsEnabled="False"
                      >
            </CheckBox>

            <CheckBox x:Name="checkBox1" Grid.Column="3" VerticalAlignment="Center" HorizontalAlignment="Center" 
                      IsEnabled="{Binding ElementName=MultistageParameterControl, 
                Path=EditingEnabled, UpdateSourceTrigger=PropertyChanged}"
                      IsChecked="{Binding Content, ElementName=MultistageParameterControl, Mode=TwoWay, ValidatesOnExceptions=True, Converter={StaticResource XToBoolConverter},
                UpdateSourceTrigger=PropertyChanged}">

            </CheckBox>
            <Label x:Name="label4" Grid.Column="4"
                   Content="{Binding DummyContent, ElementName=MultistageParameterControl, Converter={StaticResource SIToUnitStringConverter}}">
            </Label>
        </Grid>

        <!-- DatePicker Mode -->

    </Grid>
</UserControl>
